//	---------------------------------------------------------------------------
//	$Header$
//
//	(c) Copyright 2002 Anthony Bowyer-Lowe.  All rights reserved.
//
//	Anthony Bowyer-Lowe / ynohtna
//	ynohtna@ynohtna.org
//	http://www.ynohtna.org/
//	---------------------------------------------------------------------------
#pragma warning( disable : 4786 )

//	Uncomment the following line to check out the cout_messagebox implementation
//	on windows .
//	#undef WIN32

#if defined(WIN32)

#pragma comment(linker, "/SUBSYSTEM:WINDOWS")		//	No console.
#pragma comment(linker, "/ENTRY:mainCRTStartup")	//	No WinMain bollox.

#define WIN32_LEANANDMEAN	//	No crapola.
#define STRICT				//	C++ and strong typing: it's the law.
#include <windows.h>

#else

//	These hacks... Where does he get these fuggly hacks?
#define MB_OK				1
#define MB_ICONINFORMATION	2
#define MB_ICONEXCLAMATION	3
#define MB_YESNO			4
#define IDYES				1

#endif

//	Flav, what time is it?
#include <time.h>


//	---------------------------------------------------------------------------
#include <anthony/msgboxstream.h>

#include <anthony/debugstream.h>
#include <anthony/nilstream.h>
#include <anthony/teestream.h>


//	We gonna hurt you so bad --------------------------------------------------
class victim
{
	long hp_;
public:
	victim() : hp_(100)
	{	}
	void damage(long amount) {
		hp_ -= amount;
	}
	operator bool() const {
		return hp_ > 0;
	}
	long hp() const {
		return hp_;
	}
};


//	Custom stream insertion operator for victims.
template<typename E, typename T>
std::basic_ostream<E, T>& operator<<(std::basic_ostream<E, T>& os, const victim& who)
{
	os << "hp: " << who.hp();
	return os;
}


//	---------------------------------------------------------------------------
void main()
{
	namespace msgbox = anthony::msgbox;

	unsigned long seed = time(0) ^ 31337;	//	Phear meh leet rng.
	victim kenny;

	bool loop = false;
	do
	{	//	Create a message box.
		msgbox::msgboxstream mb;

		mb.style(MB_OK);

		seed = (seed * 15625 + 1) & 32767;
		long weight = seed & 0x7f;	//	[0, 127]

		//	Give the message box a title.
		mb.title() << "Dropped " << weight << " cans of beer on Kenny's head.";

		//	Squash him like a bug.
		kenny.damage(weight);

		if(kenny)
		{	//	He's still standing? Must... Try... Harder.
			mb << msgbox::icon(MB_ICONINFORMATION)
				<< "Kenny was lucky and survived." << std::endl;

			//	Note: the msgboxstream is a bona-fide ostream and thus can
			//	be used in conjunction with 'common' custom class insertion
			//	operators.
			mb << kenny << std::endl;

			mb << std::endl;
			mb << "Try harder?" << std::endl;

			mb << msgbox::buttons(MB_YESNO);
		}
		else
		{	//	Squashed the scum-bag!
			mb << msgbox::icon(MB_ICONEXCLAMATION)
				<< "Oh my god, you killed Kenny!" << std::endl
				<< std::endl
				<< "You bastard!" << std::endl;
		}

		//	Show the message box. Alternatively: mb << msgbox.display()
		mb.display();

		//	Loop whilst Kenny is alive and the player is not bored.
		loop = (kenny && IDYES == mb);
	}
	while(loop);


	{	//	Demonstrate the debugstream, teestream, and nilstream.
		anthony::nilstream devnull;
		devnull << "going nowhere" << std::endl;

		anthony::teestream tee;
#if defined(WIN32)
		tee.attach(new anthony::debugstream);
#endif
		tee.attach(std::cout);

		tee << "The older I grow, the more I distrust the" << std::endl
			<< "familiar doctrine that age brings wisdom." << std::endl;
		tee << "--  H. L. Mencken" << std::endl;
	}
}


//	---------------------------------------------------------------------------
//	eof
